#include "editdbdialog.h"
#include "ui_editdbdialog.h"

editDBDialog::editDBDialog(QSqlDatabase db_copy, QWidget *parent) :
    db(db_copy),
    QDialog(parent),
    ui(new Ui::editDBDialog)
{
    ui->setupUi(this);

    refresh();

}

editDBDialog::~editDBDialog()
{
    delete ui;
}


void editDBDialog::refresh()
{
    QStringList table_list = db.tables();
    for(QString* cur_table = table_list.begin(); cur_table != table_list.end(); ++cur_table)
    {
        ui->tablesList->addItem(*cur_table);
    }
}


void editDBDialog::on_changeTableBtn_clicked()
{
    QSqlQueryModel *model = new QSqlQueryModel;
    QSqlQuery *qry = new QSqlQuery(db);
    QString qry_str = "SELECT * FROM ";
    qry_str.append(ui->tablesList->currentItem()->text());
    qry->prepare(qry_str);
    qry->exec();
    model->setQuery(*qry);
    ui->curTableTV->setModel(model);
}


void editDBDialog::on_runQueryBtn_clicked()
{
    QString qry_str = ui->queryWnd->toPlainText();
    QSqlQuery *qry = new QSqlQuery(db);
    if (qry->exec(qry_str))
    {
        ui->queryHistory->append(qry_str);
        refresh();
        QSqlQueryModel *model = new QSqlQueryModel();
        model->setQuery(*qry);
        ui->curTableTV->setModel(model);
    }
    else
    {
        QMessageBox::warning(this, "Failed to execute query", "Query is wrong! Check it and try again.");
    }
}


void editDBDialog::on_clearBtn_clicked()
{
    ui->queryWnd->clear();
}

